uniform sampler2D tex0;

void main(void)
{
	vec4 sample = vec4(0.0);
	vec2 uv = gl_TexCoord[0].st;
	float step = 0.001;
	float a = texture2D(tex0, uv).a;

	// gaussian blur, 7x7
	sample += texture2D(tex0, uv + vec2(-3.0 * step, -3.0 * step));
	sample += texture2D(tex0, uv + vec2(-3.0 * step, -2.0 * step));
	sample += texture2D(tex0, uv + vec2(-3.0 * step,       -step));
	sample += texture2D(tex0, uv + vec2(-3.0 * step,         0.0));
	sample += texture2D(tex0, uv + vec2(-3.0 * step,        step));
	sample += texture2D(tex0, uv + vec2(-3.0 * step,  2.0 * step));
	sample += texture2D(tex0, uv + vec2(-3.0 * step,  3.0 * step));

	sample += texture2D(tex0, uv + vec2(-2.0 * step, -3.0 * step));
	sample += texture2D(tex0, uv + vec2(-2.0 * step, -2.0 * step));
	sample += texture2D(tex0, uv + vec2(-2.0 * step,       -step));
	sample += texture2D(tex0, uv + vec2(-2.0 * step,         0.0));
	sample += texture2D(tex0, uv + vec2(-2.0 * step,        step));
	sample += texture2D(tex0, uv + vec2(-2.0 * step,  2.0 * step));
	sample += texture2D(tex0, uv + vec2(-2.0 * step,  3.0 * step));

	sample += texture2D(tex0, uv + vec2(      -step, -3.0 * step));
	sample += texture2D(tex0, uv + vec2(      -step, -2.0 * step));
	sample += texture2D(tex0, uv + vec2(      -step,       -step));
	sample += texture2D(tex0, uv + vec2(      -step,         0.0));
	sample += texture2D(tex0, uv + vec2(      -step,        step));
	sample += texture2D(tex0, uv + vec2(      -step,  2.0 * step));
	sample += texture2D(tex0, uv + vec2(      -step,  3.0 * step));

	sample += texture2D(tex0, uv + vec2(        0.0, -3.0 * step));
	sample += texture2D(tex0, uv + vec2(        0.0, -2.0 * step));
	sample += texture2D(tex0, uv + vec2(        0.0,       -step));
	sample += texture2D(tex0, uv + vec2(        0.0,         0.0));
	sample += texture2D(tex0, uv + vec2(        0.0,        step));
	sample += texture2D(tex0, uv + vec2(        0.0,  2.0 * step));
	sample += texture2D(tex0, uv + vec2(        0.0,  3.0 * step));

	sample += texture2D(tex0, uv + vec2(       step, -3.0 * step));
	sample += texture2D(tex0, uv + vec2(       step, -2.0 * step));
	sample += texture2D(tex0, uv + vec2(       step,       -step));
	sample += texture2D(tex0, uv + vec2(       step,         0.0));
	sample += texture2D(tex0, uv + vec2(       step,        step));
	sample += texture2D(tex0, uv + vec2(       step,  2.0 * step));
	sample += texture2D(tex0, uv + vec2(       step,  3.0 * step));

	sample += texture2D(tex0, uv + vec2( 2.0 * step, -3.0 * step));
	sample += texture2D(tex0, uv + vec2( 2.0 * step, -2.0 * step));
	sample += texture2D(tex0, uv + vec2( 2.0 * step,       -step));
	sample += texture2D(tex0, uv + vec2( 2.0 * step,         0.0));
	sample += texture2D(tex0, uv + vec2( 2.0 * step,        step));
	sample += texture2D(tex0, uv + vec2( 2.0 * step,  2.0 * step));
	sample += texture2D(tex0, uv + vec2( 2.0 * step,  3.0 * step));

	sample += texture2D(tex0, uv + vec2( 3.0 * step, -3.0 * step));
	sample += texture2D(tex0, uv + vec2( 3.0 * step, -2.0 * step));
	sample += texture2D(tex0, uv + vec2( 3.0 * step,       -step));
	sample += texture2D(tex0, uv + vec2( 3.0 * step,         0.0));
	sample += texture2D(tex0, uv + vec2( 3.0 * step,        step));
	sample += texture2D(tex0, uv + vec2( 3.0 * step,  2.0 * step));
	sample += texture2D(tex0, uv + vec2( 3.0 * step,  3.0 * step));

	sample /= 7.0 * 7.0;
	sample.a = a;

	if (sample.r + sample.b + sample.g > 0.0)
		gl_FragColor = sample;
	else
		gl_FragColor = gl_Color;
}
