uniform sampler2D tex0;

void main(void)
{
	vec4 sample = vec4(0.0);
	vec2 uv = gl_TexCoord[0].st;
	float step = 0.005;

	// horizontal sobel
	sample +=       texture2D(tex0, uv + vec2(-step, -step));
	sample += 2.0 * texture2D(tex0, uv + vec2(-step,  0.0));
	sample +=       texture2D(tex0, uv + vec2(-step,  step));

	sample -=       texture2D(tex0, uv + vec2( step, -step));
	sample -= 2.0 * texture2D(tex0, uv + vec2( step,  0.0));
	sample -=       texture2D(tex0, uv + vec2( step,  step));

	// vertical sobel
	sample +=       texture2D(tex0, uv + vec2(-step, -step));
	sample += 2.0 * texture2D(tex0, uv + vec2(  0.0, -step));
	sample +=       texture2D(tex0, uv + vec2( step, -step));

	sample -=       texture2D(tex0, uv + vec2(-step, step));
	sample -= 2.0 * texture2D(tex0, uv + vec2(  0.0,  step));
	sample -=       texture2D(tex0, uv + vec2( step,  step));

	sample /= 2.0;
	sample.a = 1.0;

	gl_FragColor = sample;
}
